//
//  File Description:
//      This file contains the structures and prototypes
//      for 32bit interrupt routines
//

#ifndef _BIOS32_H_
#define _BIOS32_H_

// Structures and union for accessing 32bit registers with interrupt 0x1a
struct DWordRegs
{
	unsigned long eax;
	unsigned long ebx;
	unsigned long ecx;
	unsigned long edx;
	unsigned int  si;
	unsigned int  di;
	unsigned int  cflag;
};

struct WordRegs
{
	unsigned int ax;
	unsigned int hax;
	unsigned int bx;
	unsigned int hbx;
	unsigned int cx;
	unsigned int hcx;
	unsigned int dx;
	unsigned int hdx;
	unsigned int si;
	unsigned int di;
	unsigned int cflag;
};

struct ByteRegs
{
	unsigned char al, ah;
	unsigned int hax;
	unsigned char bl, bh;
	unsigned int hbx;
	unsigned char cl, ch;
	unsigned int hcx;
	unsigned char dl, dh;
	unsigned int hdx;
};

typedef union TAG_DRegs
{
	struct DWordRegs e;
	struct WordRegs x;
	struct ByteRegs h;
} DRegs;

//
// Performs int 0x1a (PCI Bios stuff)
// Allows use of 32bit registers
//
// Entry:
//      pointer to structure of registers (input and output)
//
// Return:
//      OutRegs structure updated.
//
void Bios32(DRegs *inregs, DRegs *outregs);

#endif
	
